// HWEncTestDlg.h : header file
//

#if !defined(AFX_HWENCTESTDLG_H__4E5D1080_1082_47C9_8309_DF3EE65DA4BE__INCLUDED_)
#define AFX_HWENCTESTDLG_H__4E5D1080_1082_47C9_8309_DF3EE65DA4BE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "VideoWnd.h"
#include "Resource.h"
#include "CellWnd.h"
#define TV_CHANNELS 16//4
#define MAXIPNUMBER 50
#define MAX_SERVER_NUM 256
/////////////////////////////////////////////////////////////////////////////
// CHWEncTestDlg dialog

class CHWEncTestDlg : public CDialog
{
// Construction
public:

	CHWEncTestDlg(CWnd* pParent = NULL);	// standard constructor 
	virtual ~CHWEncTestDlg();
	void InitList();
	bool InitCards();
	
	enum
    {
		MAX_PCHANNEL     = 16,
		MAX_LCHANNEL     = 256, 
    };
	
    enum
    {
        MAX_CELL_COUNT = 256,
    };

	int m_nTotalPChannel;
    int m_nTotalLChannel;
    int m_nDevideNum;
	BOOL m_bChannelProc;
	
	HANDLE   m_InitCardThread;
	bool     m_bCardInit;
	
	CImageList	m_ImageList;
	CImageList	m_ImageListTV;	

	DWORD m_dwCurrentTV;  //current output physical channel
	DWORD m_dwCurrentDevNum[16];
    DWORD m_dwDSPNum;

    //255̨
    typedef struct{
        CHAR ServerIp[32];
        DWORD  dwServerVideoPort;//ͨ˿
        CHAR UserName[32];
        CHAR Password[32];
        DWORD  NetDvrType;//dvr
        DWORD  dwChlNum;//ͨ
        CHAR ServerName[32];
        BOOL bOnLine;//ȷ½Ժ,Ϊ
        BOOL bCanbePingConnected;//ܹpingͨ
        CHAR strChlName[64][64];//ÿͨ
}NET_DVR_SERVER,*PNET_DVR_SERVER;

    DWORD m_dwCurrentListNum;
    PNET_DVR_SERVER m_pNetDvrServer[MAX_SERVER_NUM];
	BOOL m_bDirectDisplay;
	DWORD m_dwStandard;
	
private:
    const static CSize m_CellSpace;
    CCellWnd m_CellWnd[MAX_CELL_COUNT];                 // Cell window.
    CCellWnd m_FullScreenWnd;                           // Full screen window.
	
    int m_nRow;                                         // Cell window row.
    int m_nColumn;                                      // Cell window column.
    int m_nStartCell;                                   // The first cell index in the page.                         
	char m_sH264File[MAX_CELL_COUNT][255];
    char m_sYUVData[255];
    BOOL m_bOpened[MAX_CELL_COUNT];
    HANDLE m_hInputThread[MAX_CELL_COUNT];
    BOOL m_bInited;

    DWORD m_dwWidth;
    DWORD m_dwHeight;
public:

    // Get pointer to the cell window.
//    void OnRangeCell(UINT nID);

    CCellWnd* GetCellWnd( int i )
    { ASSERT(i >= 0 && i <= MAX_CELL_COUNT); return &m_CellWnd[i];}

    CCellWnd* GetActiveCellWnd() { return GetCellWnd(CCellWnd::sm_nActiveIndex); }

	void RefreshState(DWORD dwDevideNum);
	CString GetAppPath();

    // Get pointer to the full screen window.
    CCellWnd* GetFullScreen() { return &m_FullScreenWnd; }
	
    // Partition rectangle.
    BOOL PartitionRect( OUT LPRECT prcCell, int nRow, int nColumn,
        OUT LPRECT prcPlayCtrl, int nPlayCtrlHeight );
    
    // Layout all cell windows.
    BOOL LayoutCellWnd( int nStartCell, IN LPCRECT prcCell,
        int nRow, int nColumn );

    void OnEndFile(WPARAM wParam, LPARAM lParam);
    void InputThread();

public:
// Dialog Data
	//{{AFX_DATA(CHWEncTestDlg)
	enum { IDD = IDD_HWENCTEST_DIALOG };
	CComboBox	m_ComYUVList;
	CListCtrl	m_Cardlist;
	CListCtrl	m_DeCardList;
	CStatic	m_InitCard;
	BOOL	m_bCyclePlay;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHWEncTestDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CHWEncTestDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	virtual void OnOK();
	afx_msg void OnClickListCtrl(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnButtonOpenfile();
	afx_msg void OnButtonClosefile();
    afx_msg void OnRangeCell(UINT nID);
	virtual void OnCancel();
	afx_msg void OnDestroy();
	afx_msg void OnButtonFull();
	afx_msg void OnButtonOpenyuv();
	afx_msg void OnButtonCloseyuv();
	afx_msg void OnRadioCif();
	afx_msg void OnRadioD1();
	afx_msg void OnButtonResetport();
	afx_msg void OnButtonSet();
	afx_msg void OnRadio720();
	afx_msg void OnRadioQcif();
	afx_msg void OnButtonCahnnel();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HWENCTESTDLG_H__4E5D1080_1082_47C9_8309_DF3EE65DA4BE__INCLUDED_)
