// VideoWnd.cpp : implementation file
//

#include "stdafx.h"
#include "VideoWnd.h"
#include "CellWnd.h"


// CVideoWnd

const CBrush CVideoWnd::sm_brBackground( RGB(2,2,2) );
//const CBrush CVideoWnd::sm_brBackground( RGB(255,255,255) );
IMPLEMENT_DYNAMIC(CVideoWnd, CWnd)

CVideoWnd::CVideoWnd()
{
    WNDCLASS wndClass = {0};
    wndClass.lpfnWndProc   = ::DefWindowProc;
    wndClass.hInstance     = AfxGetInstanceHandle();
    wndClass.hCursor       = AfxGetApp()->LoadStandardCursor(IDC_ARROW);
    wndClass.hbrBackground = (HBRUSH)sm_brBackground;
    wndClass.lpszClassName = VIDEO_WINDOW_CLASS;
	m_bEraseBkgnd = FALSE;
    VERIFY( AfxRegisterClass( &wndClass ) );
}

CVideoWnd::~CVideoWnd()
{
}


BEGIN_MESSAGE_MAP(CVideoWnd, CWnd)
    ON_WM_LBUTTONDOWN()
    ON_WM_RBUTTONDOWN()
    ON_WM_PAINT()
    ON_WM_ERASEBKGND()
END_MESSAGE_MAP()


// CVideoWnd message handlers


void CVideoWnd::OnLButtonDown(UINT nFlags, CPoint point)
{
    // TODO: Add your message handler code here and/or call default
    CPoint pt = point;
    ClientToScreen( &pt );
    
    CWnd* pParent = GetParent();
    if ( pParent )
    {
        pParent->ScreenToClient( &pt );
        pParent->PostMessage( WM_LBUTTONDOWN, nFlags, MAKEWPARAM(pt.x, pt.y) );
    }

    CWnd::OnLButtonDown(nFlags, point);
}


void CVideoWnd::OnRButtonDown(UINT nFlags, CPoint point)
{
    // TODO: Add your message handler code here and/or call default
    CPoint pt = point;
    ClientToScreen( &pt );

    CWnd* pParent = GetParent();
    if ( pParent )
    {
        pParent->ScreenToClient( &pt );
        pParent->PostMessage( WM_RBUTTONDOWN, nFlags, MAKEWPARAM(pt.x, pt.y) );
    }

    CWnd::OnRButtonDown(nFlags, point);
}


void CVideoWnd::OnPaint()
{
    CPaintDC dc(this); // device context for painting
    // TODO: Add your message handler code here
    // Do not call CWnd::OnPaint() for painting messages
    CCellWnd* pCellWnd = (CCellWnd*)GetParent();
    ASSERT_VALID(pCellWnd);

//    if ( CCellWnd::NOT_OPENED == pCellWnd->m_Play.OpenMode )
    {
        CRect rc;
        GetClientRect( rc );

        COLORREF OldTextColor = dc.SetTextColor( RGB(100,100,100) );
        int nOldBkMode = dc.SetBkMode( TRANSPARENT );

        CString strIndex;
        strIndex.Format(_T("%d"), pCellWnd->m_nIndex+1);
        dc.TextOut( 0, 0, strIndex );
        //dc.DrawText( strIndex, rc, DT_CENTER | DT_VCENTER | DT_SINGLELINE );

        dc.SetBkMode( nOldBkMode );
        dc.SetTextColor( OldTextColor );
    }
}

BOOL CVideoWnd::OnEraseBkgnd(CDC* pDC)
{
	// TODO: Add your message handler code here and/or call default
    CCellWnd* pCellWnd = (CCellWnd*)GetParent();
    ASSERT_VALID(pCellWnd);
	if ( m_bEraseBkgnd )
	{
		CRect rc; 	
        GetClientRect( rc ); 
        pDC->ExcludeClipRect(&rc); 
	}

	return CWnd::OnEraseBkgnd(pDC);
}
